<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for authentication StructType
 * @subpackage Structs
 */
class Authentication extends AbstractStructBase
{
    /**
     * The eazieerkey
     * @var string
     */
    public $eazieerkey;
    /**
     * The sourceapplication
     * @var string
     */
    public $sourceapplication;
    /**
     * The login
     * @var string
     */
    public $login;
    /**
     * The password
     * @var string
     */
    public $password;
    /**
     * The entity
     * @var string
     */
    public $entity;
    /**
     * Constructor method for authentication
     * @uses Authentication::setEazieerkey()
     * @uses Authentication::setSourceapplication()
     * @uses Authentication::setLogin()
     * @uses Authentication::setPassword()
     * @uses Authentication::setEntity()
     * @param string $eazieerkey
     * @param string $sourceapplication
     * @param string $login
     * @param string $password
     * @param string $entity
     */
    public function __construct($eazieerkey = null, $sourceapplication = null, $login = null, $password = null, $entity = null)
    {
        $this
            ->setEazieerkey($eazieerkey)
            ->setSourceapplication($sourceapplication)
            ->setLogin($login)
            ->setPassword($password)
            ->setEntity($entity);
    }
    /**
     * Get eazieerkey value
     * @return string|null
     */
    public function getEazieerkey()
    {
        return $this->eazieerkey;
    }
    /**
     * Set eazieerkey value
     * @param string $eazieerkey
     * @return \StructType\Authentication
     */
    public function setEazieerkey($eazieerkey = null)
    {
        // validation for constraint: string
        if (!is_null($eazieerkey) && !is_string($eazieerkey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($eazieerkey)), __LINE__);
        }
        $this->eazieerkey = $eazieerkey;
        return $this;
    }
    /**
     * Get sourceapplication value
     * @return string|null
     */
    public function getSourceapplication()
    {
        return $this->sourceapplication;
    }
    /**
     * Set sourceapplication value
     * @param string $sourceapplication
     * @return \StructType\Authentication
     */
    public function setSourceapplication($sourceapplication = null)
    {
        // validation for constraint: string
        if (!is_null($sourceapplication) && !is_string($sourceapplication)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($sourceapplication)), __LINE__);
        }
        $this->sourceapplication = $sourceapplication;
        return $this;
    }
    /**
     * Get login value
     * @return string|null
     */
    public function getLogin()
    {
        return $this->login;
    }
    /**
     * Set login value
     * @param string $login
     * @return \StructType\Authentication
     */
    public function setLogin($login = null)
    {
        // validation for constraint: string
        if (!is_null($login) && !is_string($login)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($login)), __LINE__);
        }
        $this->login = $login;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \StructType\Authentication
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get entity value
     * @return string|null
     */
    public function getEntity()
    {
        return $this->entity;
    }
    /**
     * Set entity value
     * @param string $entity
     * @return \StructType\Authentication
     */
    public function setEntity($entity = null)
    {
        // validation for constraint: string
        if (!is_null($entity) && !is_string($entity)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($entity)), __LINE__);
        }
        $this->entity = $entity;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Authentication
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
